\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ This program provides the computational steps to prove Section 6.1


#solutions_D2 = [[6,3, 2, 2*sqrt(2)]]
#solutions_D3 = [[12,6, 1, 2*sqrt(3) - 2], [12,6, 5, 2*sqrt(3) + 2],[24,3, 4, 2*sqrt(1/3)], [24,15, 4, #2*sqrt(1/3)]]
#solutions_D6 = [[[6,3, 1, 2*sqrt(2/3)]]]
#solutions_D33 = [[6,1, 1, 1/2*sqrt(11/3) + 1/2],[6,5, 1, 1/2*sqrt(11/3) - 1/2]]

D = 12

K.<x> = QuadraticField(D)
l = K.embeddings(RR)
m = [(l[k](x),k) for k in xrange(2)]
phi = l[max(m)[1]]

# LIST OF SOLUTIONS FOR PRYM(1,1,2)GIVEN IN TERMS OF THE GENERATOR x OF K
# UNCOMMENT/COMMENT THE CORRESPONDING LINE IN FUNCTION OF D (HERE D=33)
solutions_D2 = [[6,3, 2, 2*x],[6,3, 4, 2*x]]
solutions_D3 = [[24,12, 2, 2*x - 2], [24,12, 10, 2*x + 2],[24,3, 4, 2*x/3], [24,15, 4, 2*x/3],[24,12, 22, 2*x - 2], [24,12, 14, 2*x + 2],[24,21, 20, 2*x/3], [24,9, 20, 2*x/3]]
solutions_D6 = [[6,3, 1, 2*x/3],[6,3, 5, 2*x/3]]
solutions_D33 = [[6,1, 1, 1/2*x/3 + 1/2],[6,5, 1, 1/2*x/3 - 1/2],[6,5, 5, 1/2*x/3 + 1/2],[6,1, 5, 1/2*x/3 - 1/2]]


def dual_basis(r):
    Re = r.trace()/2
    Im = (r-r.norm()/r)/2
    return [(1/2 - Re/(2*Im)) , (1/(2*Im))]

# CHECK WHETHER A MATRIX M IS AN INTEGRAL POSITIVE MATRIX
def M_is_integral_positive(M):
    return (M[0][0] in NN) and (M[0][1] in NN) and (M[1][0] in NN) and (M[1][1] in NN)

# GALOIS CONJUGATE
def galois(r):
    if r in QQ: return r
    return r.norm()/r


def M_intersection_matrix(r2_hor,r2_ver,gamma):
    s = dual_basis(r2_hor)
    h = [s[0]/2,s[1]]
    h_galois= [galois(r) for r in h]
    H = matrix([h,h_galois]).transpose()
    
    w = [h[0]/gamma,r2_ver*h[0]/gamma] #BETA CROSSES C1
    w_bis = [h[1]/gamma,r2_ver*h[1]/gamma] #BETA CROSSES C2
    w_galois = [galois(r) for r in w]
    w_bis_galois = [galois(r) for r in w_bis]
    W = matrix([w,w_galois]).transpose()
    W_bis = matrix([w_bis,w_bis_galois]).transpose()
    return [(W*(H.inverse())).transpose(),(W_bis*(H.inverse())).transpose()]
    
    
def possible_periods(N,n,m,r2):
        p = -n/N + r2*m/N # simplest relative period
	periods = [ ]
	for k in xrange(-2,2+1):
	   for l in xrange(-1,2):
		pe = p + k + l*r2
                if phi(pe) > 0 and phi(pe-r2)<0:
                   #print "[k,l]= " + str([k,l]) + " " + str(pe)
		   periods.append([pe,k,l])
	return periods

def possible_reduced_matrices(sol):
    for i in sol:
        for j in sol:
            poss_periods = possible_periods(j[0],j[1],j[2],j[3])
            for pp in poss_periods:
                beta = pp[0]
                M = M_intersection_matrix(i[3],j[3],beta)
                # 0 if BETA CROSSES C1 and 1 if BETA CROSSES C2
                #if M_is_integral_positive(M[0]) and mod(M[0][0,1],2)==0: print [M[0],i[3],beta]; print
                if M_is_integral_positive(M[1]) and mod(M[1][0,1],2)==0: print [M[1],i[3]]; print
    return "END"